/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of normalize.xs. Do not edit this file, edit normalize.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "normalize.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include <perliol.h>
#include <string.h>

typedef enum {
  NFC,
  NFD,
  NFKC,
  NFKD,
  FCD,
  FCC,
} normalization;

typedef struct {
  PerlIOBuf buf;
  SV *data;
  normalization norm;
} PerlIOnormalize;

normalization
parse_parameters(pTHX_ SV* param)
{
  STRLEN len;
  const char* begin;
  if (param && SvOK(param)) {
    begin = SvPV(param, len);
    if (len) {
      if (strncmp(begin, "NFC", len) == 0)  { return NFC; }
      if (strncmp(begin, "NFD", len) == 0)  { return NFD; }
      if (strncmp(begin, "NFKC", len) == 0) { return NFKC; }
      if (strncmp(begin, "NFKD", len) == 0) { return NFKD; }
      if (strncmp(begin, "FCD", len) == 0)  { return FCD; }
      if (strncmp(begin, "FCC", len) == 0)  { return FCC; }
    }
  }

  Perl_croak(aTHX_ ":normalize requires an argument of NFC, NFD, NFKC, NFKD, FCD, or FCC.");
}

IV
PerlIOnormalize_pushed(pTHX_ PerlIO* f, const char* mode, SV* arg, PerlIO_funcs *tab)
{
  normalization norm = parse_parameters(aTHX_ arg);
  if (PerlIOBuf_pushed(aTHX_ f, mode, arg, tab) == 0) {
    PerlIOBase(f)->flags |= PERLIO_F_UTF8;
    PerlIOSelf(f, PerlIOnormalize)->norm = norm;
    return 0;
  }
  return -1;
}

STRLEN
do_normalize(pTHX_ normalization norm, SV *input, char **out) {
  dSP;
  SV *nf, *output;
  char *temp = NULL;
  STRLEN len = 0;

  switch(norm) {
    case NFC:  nf = newSVpvn("NFC",  3); break;
    case NFD:  nf = newSVpvn("NFD",  3); break;
    case NFKC: nf = newSVpvn("NFKC", 4); break;
    case NFKD: nf = newSVpvn("NFKD", 4); break;
    case FCD:  nf = newSVpvn("FCD",  3); break;
    case FCC:  nf = newSVpvn("FCC",  3); break;
    default: Perl_croak(aTHX_ "Unknown normalization form %d", norm); break;
  }

  ENTER;
  SAVETMPS;

  PUSHMARK(sp);
  XPUSHs(nf);
  XPUSHs(input);
  PUTBACK;

  if (call_pv("Unicode::Normalize::normalize", G_SCALAR) != 1) {
    Perl_croak(aTHX_ "normalize returned nothing");
  }
  SPAGAIN;

  output = POPs;
  if (SvPOK(output)) {
    temp = SvPVutf8(output, len);
  }

  *out = (char *)malloc(len);
  if (*out == NULL) {
    Perl_croak(aTHX_ "Could not allocate memory for return value of normalization");
  }
  memcpy(*out, temp, len);

  if (len <= 0) {
    Perl_croak(aTHX_ "normalize returned an empty string");
  }

  PUTBACK;
  FREETMPS;
  LEAVE;

  return len;
}

IV
PerlIOnormalize_fill(pTHX_ PerlIO *f)
{
  PerlIO *nx = PerlIONext(f);
  SSize_t avail;

  /* make sure we have a buffer layer */
  if (!PerlIO_fast_gets(nx)) {
    char mode[8];
    nx = PerlIO_push(aTHX_ nx, &PerlIO_perlio, PerlIO_modestr(f,mode), Nullsv);
    if (!nx) {
      Perl_croak(aTHX_ "cannot push :perlio for %p", f);
    }
  }

  avail = PerlIO_get_cnt(nx);
  if (avail <= 0) {
    avail = PerlIO_fill(nx);
    if (avail == 0) {
      avail = PerlIO_get_cnt(nx);
    } else {
      if (!PerlIO_error(nx) && PerlIO_eof(nx)) {
        avail = 0;
      }
    }
  }

  if (avail > 0) {
    PerlIOnormalize *nz = PerlIOSelf(f, PerlIOnormalize);
    STDCHAR *ptr = PerlIO_get_ptr(nx);
    SV *input;
    char *out;
    STRLEN len = 0;

    nz->buf.ptr = nz->buf.end = (STDCHAR *) NULL;
    input = newSVpvn(ptr, avail);
    SvUTF8_on(input);

    len = do_normalize(aTHX_ nz->norm, input, &out);

    nz->data = newSVpvn(out,len);
    free(out);

    nz->buf.ptr = nz->buf.buf = (STDCHAR*)SvPVX(nz->data);
    nz->buf.end = nz->buf.ptr + SvCUR(nz->data);
    PerlIOBase(f)->flags |= PERLIO_F_RDBUF;
    SvUTF8_on(nz->data);

    PerlIO_set_ptrcnt(nx, ptr+avail, 0);

    return 0;
  }
  
  if (avail == 0) {
    /* EOF reached */
    PerlIOBase(f)->flags |= PERLIO_F_EOF;
  } else {
    PerlIOBase(f)->flags |= PERLIO_F_ERROR;
    Perl_PerlIO_save_errno(aTHX_ f);
  }

  return -1;
}

IV
PerlIOnormalize_flush(pTHX_ PerlIO *f)
{
  PerlIOnormalize *nz = PerlIOSelf(f, PerlIOnormalize);

  if ((PerlIOBase(f)->flags & PERLIO_F_WRBUF) && (nz->buf.ptr > nz->buf.buf)) {
    PerlIO *nx = PerlIONext(f);
    STDCHAR *ptr = nz->buf.buf;
    Size_t avail = nz->buf.ptr - nz->buf.buf;
    SV *input;
    char *out;
    STRLEN len = 0;
    SSize_t count = 0;

    input = newSVpvn(ptr, avail);
    SvUTF8_on(input);

    len = do_normalize(aTHX_ nz->norm, input, &out);

    count = PerlIO_write(nx, out, len);
    free(out);

    if ((STRLEN)count != len) {
      return -1;
    }

    return 0;
  }
  
  return PerlIOBuf_flush(aTHX_ f);
}

PerlIO_funcs PerlIO_normalize = {
  sizeof(PerlIO_funcs),
  "normalize",
  sizeof(PerlIOnormalize),
  PERLIO_K_BUFFERED | PERLIO_K_UTF8,
  PerlIOnormalize_pushed,
  PerlIOBuf_popped,      /* IV        PerlIOnormalize_popped */
  PerlIOBuf_open,
  PerlIOBase_binmode,
  NULL,
  PerlIOBase_fileno,
  PerlIOBuf_dup,
  PerlIOBuf_read,        /* SSize_t   PerlIOnormalize_read */
  PerlIOBuf_unread,      /* SSize_t   PerlIOnormalize_unread */
  PerlIOBuf_write,       /* SSize_t   PerlIOnormalize_write */
  PerlIOBuf_seek,
  PerlIOBuf_tell,
  PerlIOBuf_close,
  PerlIOnormalize_flush,
  PerlIOnormalize_fill,
  PerlIOBase_eof,
  PerlIOBase_error,
  PerlIOBase_clearerr,
  PerlIOBase_setlinebuf,
  PerlIOBuf_get_base,
  PerlIOBuf_bufsiz,
  PerlIOBuf_get_ptr,
  PerlIOBuf_get_cnt,
  PerlIOBuf_set_ptrcnt,
};

#line 245 "normalize.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 389 "normalize.c"
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_PerlIO__normalize); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_PerlIO__normalize)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif


    /* Initialisation Section */

#line 240 "normalize.xs"
  PerlIO_define_layer(aTHX_ &PerlIO_normalize);

#line 417 "normalize.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

